#version 120

out vec2 TexCoords;
out vec4 Color;

vec3 DistortPosition(vec3 shadowClipPos){
    float distortionFactor = length(shadowClipPos.xy);
	distortionFactor += 0.09;
	shadowClipPos.xy /= distortionFactor;
	shadowClipPos.z *= 0.5;
	return shadowClipPos;
}

void main(){
    gl_Position = ftransform();
    gl_Position.xyz = DistortPosition(gl_Position.xyz);
    TexCoords = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
    Color = gl_Color;
}